package org.jeecg.modules.stm.project.execrisk.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.project.execrisk.service.IStProjectExecRiskService;
import org.jeecg.modules.stm.project.execrisk.entity.StProjectExecRisk;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 项目实施风险
 * @Author: jeecg-boot
 * @Date:   2023-08-17
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/project.execrisk/stProjectExecRisk")
@Slf4j
public class StProjectExecRiskController extends JeecgController<StProjectExecRisk, IStProjectExecRiskService> {
	@Autowired
	private IStProjectExecRiskService stProjectExecRiskService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stProjectExecRisk
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "项目实施风险-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StProjectExecRisk>> queryPageList(StProjectExecRisk stProjectExecRisk,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StProjectExecRisk> queryWrapper = QueryGenerator.initQueryWrapper(stProjectExecRisk, req.getParameterMap());
		Page<StProjectExecRisk> page = new Page<StProjectExecRisk>(pageNo, pageSize);
		IPage<StProjectExecRisk> pageList = stProjectExecRiskService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stProjectExecRisk
	 * @return
	 */
	@AutoLog(value = "项目实施风险-添加")
	  
	@RequiresPermissions("project.execrisk:st_project_exec_risk:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StProjectExecRisk stProjectExecRisk) {
		stProjectExecRiskService.save(stProjectExecRisk);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stProjectExecRisk
	 * @return
	 */
	@AutoLog(value = "项目实施风险-编辑")
	  
	@RequiresPermissions("project.execrisk:st_project_exec_risk:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StProjectExecRisk stProjectExecRisk) {
		stProjectExecRiskService.updateById(stProjectExecRisk);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "项目实施风险-通过id删除")
	  
	@RequiresPermissions("project.execrisk:st_project_exec_risk:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stProjectExecRiskService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "项目实施风险-批量删除")
	  
	@RequiresPermissions("project.execrisk:st_project_exec_risk:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stProjectExecRiskService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "项目实施风险-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StProjectExecRisk> queryById(@RequestParam(name="id",required=true) String id) {
		StProjectExecRisk stProjectExecRisk = stProjectExecRiskService.getById(id);
		if(stProjectExecRisk==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stProjectExecRisk);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stProjectExecRisk
    */
    @RequiresPermissions("project.execrisk:st_project_exec_risk:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StProjectExecRisk stProjectExecRisk) {
        return super.exportXls(request, stProjectExecRisk, StProjectExecRisk.class, "项目实施风险");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("project.execrisk:st_project_exec_risk:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StProjectExecRisk.class);
    }

}
